## START: Set by rpmautospec
## (rpmautospec version 0.6.5)
## RPMAUTOSPEC: autorelease, autochangelog
%define autorelease(e:s:pb:n) %{?-p:0.}%{lua:
    release_number = 4;
    base_release_number = tonumber(rpm.expand("%{?-b*}%{!?-b:1}"));
    print(release_number + base_release_number - 1);
}%{?-e:.%{-e*}}%{?-s:.%{-s*}}%{!?-n:%{?dist}}
## END: Set by rpmautospec

%global _hardened_build 1

Summary: Bidirectional data relay between two data channels ('netcat++')
Name: socat
Version: 1.8.0.3
Release: 0%{?dist}.1sunshine
License: GPL-2.0-only
Url:  http://www.dest-unreach.org/socat/
Source: http://www.dest-unreach.org/socat/download/%{name}-%{version}.tar.gz

BuildRequires: make
BuildRequires:  gcc
BuildRequires: openssl-devel readline-devel ncurses-devel
BuildRequires: autoconf kernel-headers > 2.6.18
# for make test
BuildRequires: iproute net-tools coreutils openssl iputils
%if 0%{?fedora} < 11
BuildRequires: procps
%else
BuildRequires: procps-ng
%endif

%description
Socat is a relay for bidirectional data transfer between two independent data
channels. Each of these data channels may be a file, pipe, device (serial line
etc. or a pseudo terminal), a socket (UNIX, IP4, IP6 - raw, UDP, TCP), an
SSL socket, proxy CONNECT connection, a file descriptor (stdin etc.), the GNU
line editor (readline), a program, or a combination of two of these.


%prep
%setup -q
iconv -f iso8859-1 -t utf-8 CHANGES > CHANGES.utf8
mv CHANGES.utf8 CHANGES
#%%autopatch -p1

%build
# avoid warning on stderr disrupting tests
sed -i "s/FGREP=fgrep/FGREP='grep -F'/" configure
sed -i "s/fgrep/grep -F/" test.sh
sed -i "s/egrep/egrep -E/" test.sh
%configure  \
        --enable-help --enable-stdio \
        --enable-fdnum --enable-file --enable-creat \
        --enable-gopen --enable-pipe --enable-termios \
        --enable-unix --enable-ip4 --enable-ip6 \
        --enable-rawip --enable-tcp --enable-udp \
        --enable-listen --enable-proxy --enable-exec \
        --enable-system --enable-pty --enable-readline \
        --enable-openssl --enable-sycls --enable-filan \
        --enable-retry # --enable-fips

%make_build

%install
 %make_install
install -d %{buildroot}/%{_docdir}/socat
install -m 0644 *.sh %{buildroot}/%{_docdir}/socat/
echo ".so man1/socat.1" | gzip > %{buildroot}/%{_mandir}/man1/filan.1.gz
cp -a %{buildroot}/%{_mandir}/man1/filan.1.gz %{buildroot}/%{_mandir}/man1/procan.1.gz

%check
# intermittently, some tests fail and just hang

# FAILED on all arches: 146 478 528
# 146 OPENSSLLISTENDSA FAILED
# 478 SIGUSR1_STATISTICS FAILED
# 528 PROCAN_CTTY FAILED
FAILED_TESTS="146 478 528"


%ifarch i386 i686
# 513 ABSTRACT_LISTEN_CONNECT_BIND_TEMPNAME FAILED
FAILED_TESTS="$FAILED_TESTS 513"
%endif

# FAILED on i686: 311 313 513
# not covered here

%ifarch x86_64
# native, not in koji/copr:
# 465 FILAN_SHORT_TCP FAILED
# 504 RES_NSADDR FAILED
# 590 OPENSSL_CONNECT_MAXCHILDREN FAILED
# 591 SOCKS4_MAXCHILDREN FAILED
# 592 SOCKS5_CONNECT_MAXCHILDREN FAILED
# 593 PROXY_CONNECT_MAXCHILDREN FAILED
FAILED_TESTS="$FAILED_TESTS 465 504 590 591 592 593"
%endif

%ifarch ppc64le
# a lot of random failures?
# 65 UNIXCONNECT_HALFCLOSE FAILED
# 66 UNIXCLIENT_HALFCLOSE FAILED
# 102 READLINE FAILED
# 170 UNIXDGRAM FAILED
# 466 RESTORE_TTY FAILED
# 495 POSIXMQ_RECV_MAXCHILDREN FAILED
# 496 POSIXMQ_SEND_MAXCHILDREN FAILED
# 509 UNIX_LISTEN_CONNECT_BIND_TEMPNAME FAILED
# 510 UNIX_LISTEN_CLIENT_BIND_TEMPNAME FAILED
# 511 UNIX_RECVFROM_CLIENT_BIND_TEMPNAME FAILED
# 513 ABSTRACT_LISTEN_CONNECT_BIND_TEMPNAME FAILED
# 518 STDIN_F_SETPIPE_SZ FAILED
# 519 EXEC_F_SETPIPE_SZ FAILED
FAILED_TESTS="$FAILED_TESTS 65 66 102 170 466 495 496 509 510 511 513 518 519"
%endif

%ifarch s390x
# 202 FS_NOATIME FAILED
# 493 POSIXMQ_READ_PRIO FAILED
FAILED_TESTS="$FAILED_TESTS 202 493"
%endif

%if (0%{?rhel} && 0%{?rhel} < 10)
# copr EPEL-7:
# 386 OPENSSL_ECDHE FAILED
# 400 OPENSSL_DTLS_SERVER FAILED
FAILED_TESTS="$FAILED_TESTS 386 400"
%endif

export TERM=ansi
export OD_C=/usr/bin/od
if [ "$FAILED_TESTS" != "" ]; then
    FIRST=1
    REPLACE="test "
    for testcase in $FAILED_TESTS; do
        if [ $FIRST = 0 ]; then
            # append "-a" for subsequent entries
            REPLACE="$REPLACE -a "
        else
            FIRST=0
        fi
        REPLACE="${REPLACE}\\\\\$N -ne $testcase"
    done
    sed -i 's/NUMCOND=true/NUMCOND="'"$REPLACE"'"/' test.sh
fi
# execute, and list failed tests
make test || (grep FAILED results.txt && false)

%files
%doc BUGREPORTS CHANGES DEVELOPMENT EXAMPLES FAQ PORTING
%doc COPYING* README SECURITY
%doc %{_docdir}/socat/*.sh
%{_bindir}/socat*
%{_bindir}/filan
%{_bindir}/procan
%doc %{_mandir}/man1/*

%changelog
* Tue Jun 03 2025 Moritz Barsnick <moritz+rpm@barsnick.net> 1.8.0.3-0.1sunshine
- update to 1.8.0.3
- adapt BR procps-ng for F10
- fix %%changelog dates for older rpmbuild
- run tests on all platforms
- report failed tests (to help adapt the given list)
- update list of tests known to fail

* Sat Jul 20 2024 Fedora Release Engineering <releng@fedoraproject.org> - 1.8.0.0-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_41_Mass_Rebuild

* Mon Apr 29 2024 František Hrdina <fhrdina@redhat.com> - 1.8.0.0-3
- Adding fmf plans and gating.yaml

* Tue Feb 20 2024 Paul Wouters <paul.wouters@aiven.io> - 1.8.0.0-2
- Update to 1.8.0.0

* Tue Feb 20 2024 Paul Wouters <paul.wouters@aiven.io> - 1.8.0.0-1
- Update to 1.8.0.0

* Sat Jan 27 2024 Fedora Release Engineering <releng@fedoraproject.org> - 1.7.4.4-7
- Rebuilt for https://fedoraproject.org/wiki/Fedora_40_Mass_Rebuild

* Mon Oct 02 2023 Martin Osvald <mosvald@redhat.com> - 1.7.4.4-6
- Migrate License field to SPDX format

* Sat Jul 22 2023 Fedora Release Engineering <releng@fedoraproject.org> - 1.7.4.4-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_39_Mass_Rebuild

* Sat Jan 21 2023 Fedora Release Engineering <releng@fedoraproject.org> - 1.7.4.4-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_38_Mass_Rebuild

* Tue Jan 17 2023 Paul Wouters <paul.wouters@aiven.io> - 1.7.4.4-3
- use make macros

* Tue Jan 17 2023 Paul Wouters <paul.wouters@aiven.io> - 1.7.4.4-2
- pull up date :P

* Tue Jan 17 2023 Clemens Lang <cllang@redhat.com> - 1.7.4.4-1
- Resolves: rhbz#2038615 socat-1.7.4.4 is available

* Mon Dec 12 2022 Florian Weimer <fweimer@redhat.com> - 1.7.4.2-4
- Port configure script to C99 (#2152488)

* Sat Jul 23 2022 Fedora Release Engineering <releng@fedoraproject.org> - 1.7.4.2-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_37_Mass_Rebuild

* Sat Jan 22 2022 Fedora Release Engineering <releng@fedoraproject.org> - 1.7.4.2-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_36_Mass_Rebuild

* Thu Nov 04 2021 Davide Cavalca <dcavalca@fedoraproject.org> - 1.7.4.2-1
- Resolves: rhbz#2018835 socat-1.7.4.2 is available

* Tue Sep 14 2021 Sahana Prasad <sahana@redhat.com> - 1.7.4.1-4
- Rebuilt with OpenSSL 3.0.0

* Fri Jul 23 2021 Fedora Release Engineering <releng@fedoraproject.org> - 1.7.4.1-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_35_Mass_Rebuild

* Wed Jan 27 2021 Fedora Release Engineering <releng@fedoraproject.org> - 1.7.4.1-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_34_Mass_Rebuild

* Mon Jan 11 2021 Paul Wouters <pwouters@redhat.com> - 1.7.4.1-1
- Resolves: rhbz#1914653 socat-1.7.4.1 is available

* Fri Jan 08 2021 Tom Stellard <tstellar@redhat.com> - 1.7.4.0-3
- Add BuildRequires: make

* Tue Jan 05 2021 Paul Wouters <pwouters@redhat.com> - 1.7.4.0-2
- add socat-1.7.4.0-uint64_t.patch

* Tue Jan 05 2021 Paul Wouters <pwouters@redhat.com> - 1.7.4.0-1
- Resolves: rhbz#1912161 socat-1.7.4.0 is available

* Wed Jul 29 2020 Fedora Release Engineering <releng@fedoraproject.org> - 1.7.3.4-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_33_Mass_Rebuild

* Thu Jan 30 2020 Fedora Release Engineering <releng@fedoraproject.org> - 1.7.3.4-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_32_Mass_Rebuild

* Mon Jan 06 2020 Paul Wouters <pwouters@redhat.com> - 1.7.3.4-2
- RPMAUTOSPEC: unresolvable merge
## END: Generated by rpmautospec
